function main() {
  
  //Send email on fail (mailApp.Send at the very bottom)
  try{
  
    /*
  1) Get config spreadsheet here:  https://docs.google.com/spreadsheets/d/1vHFKyXrYH4N4NOdfxG386gqgx3_-pAnng7E2diE9goI/copy
  2) Define thresholds     
  3) Enter the ID your config spreadsheet into spreadsheetId variable below.
  E.g. your Google Sheet URL is: https://docs.google.com/spreadsheets/d/1fCJK9UEwAU_57XvSM1B4JMWskdjksjdY-52KvtoZhWFlCauLKCg/edit#gid=0
  So you need to extract the string between '/d/' and '/edit'
  2020-02-13: Starting from this date, this script is fully stored in one js unlike before where major part of the script was called remotely. The reason for the change is the fact that Google no longer allows certain type of calls to Google Drive.  

  */  
  
  var spreadsheetId = 'blablabla'
  
  //Let's get the needed scopes.
  DriveApp.getStorageLimit()
  MailApp.getRemainingDailyQuota()
  SpreadsheetApp.openById(spreadsheetId)
  
  //###########################################################################
  //***DO NOT TOUCH ANYTHING BELOW***
  var ss = SpreadsheetApp.openById(spreadsheetId)
  var sheet = ss.getSheetByName('neg_kws_lists')
  var sqtReportSheetName = "search_terms_script"
  var sqtNewNegKwsSheetName = "do_not_touch_search_terms_new_neg_kws"
  var allNegsAsListSheetName = "all_negs_as_list"
  var negListsAsListSheetName = 'neg_lists_as_list'
  var lookbackWindow = ss.getRangeByName('lookbackWindow').getValue()
  var clicksThreshold = ss.getRangeByName('clicksThreshold').getValue()
  
  var emailAddress = ss.getRangeByName('email').getValue().toString()
  Logger.log(emailAddress)
  
  var reportingAllowed = ss.getRangeByName('reportingAllowed').getValue()
  var removeExistingAssociations = ss.getRangeByName('removeExistingAssociations').getValue()
  var lastRow = sheet.getLastRow()
  Logger.log('lastRow='+lastRow)
  
  try{var lastQueryRow = ss.getSheetByName(sqtReportSheetName).getLastRow()}
  catch(err){var lastQueryRow = 0}
  
  //###########################################################################
  //###########################################################################
  
  //GA Reporting  
  var payload = {
    'v': '1',
    'tid': 'UA-69459605-1',
    't': 'event',
    'cid' : Utilities.getUuid(),
    'z' : Math.floor(Math.random() * 10E7),
    'ds' : 'google_ads_script',
    'cn' : 'script-negative_kw_manager',
    'cs' : 'google_ads_script',
    'cm' : 'google_ads_script',
    'ec' : 'script_run',
    'ea' : 'script_run_started',
    'el' : 'script-negative_kw_manager'
    };
  
  var options = {
    "method" : "post",
    "payload" : payload
   };
  
  //Send the hit to GA if allowed
  if(reportingAllowed == 'YES'){UrlFetchApp.fetch("http://www.google-analytics.com/collect", options)};    
  
  //###########################################################################
  //###########################################################################
  
  //Let's get basic account info
  var accountName = AdsApp.currentAccount().getName()
  var accountId = AdsApp.currentAccount().getCustomerId()
    
  //Let's get list names
  var secondRow = sheet.getRange('2:2').getValues()[0]
  
  Logger.log(secondRow)
  
  var listNames = []
  
  Logger.log('Checkpoint 53')

  //Take every 3rd value and use it as list name
  for(i=0;i<secondRow.length;i+=3){

    var listNameWithIndex = []
    var listName = secondRow[i]
    //Logger.log(listName)

    var index = secondRow.indexOf(secondRow[i])+1
    
    //Only if list name exists
    if(listName.length>0){
       
      listNameWithIndex.push(listName)
      listNameWithIndex.push(index)

      listNames.push(listNameWithIndex)
    }
  }

  Logger.log('List names: ')
  Logger.log(listNames)
  
  //Let's get list names without indexes
  var listNamesWithoutIndexes = []
  for(i=0;i<listNames.length;i++){
    listNamesWithoutIndexes.push(listNames[i][0])
  }
  
  Logger.log('Checkpoint 62')

  //##########################################################################################
  //##########################################################################################
  
  //Let's see if there are some new neg KWs to be sent to negative lists from the previous run
  try{ss.insertSheet(sqtNewNegKwsSheetName)}catch(err){Logger.log('Sheet '+sqtNewNegKwsSheetName+' already exists so nothing to insert.')}
  var sqtNewNegKwsSheet = ss.getSheetByName(sqtNewNegKwsSheetName)
  try{sqtNewNegKwsSheet.deleteColumns(12, 10)}catch(err){Logger.log('XXXXX' + err)}
  sqtNewNegKwsSheet.setTabColor('pink')
  sqtNewNegKwsSheet.activate()
  //ss.moveActiveSheet(15)   

  var queryFormula = ('=query(search_terms_script!A:K,\"SELECT * WHERE J<>\'\' AND K<>\'\'\")')
  sqtNewNegKwsSheet.getRange('A1').clearContent()
  sqtNewNegKwsSheet.getRange('A1').setFormula(queryFormula)
  
  var lastRowNewNegKws = sqtNewNegKwsSheet.getLastRow()
  
  var negKwsToAddToTheList = sqtNewNegKwsSheet.getRange('A1:K'+lastRowNewNegKws).getValues()
  
  Logger.log(negKwsToAddToTheList)
  
  //Now the distributing magic
  //Let's add some new rows to the bottom
  for(i=1;i<negKwsToAddToTheList.length;i++){
    SpreadsheetApp.flush()
    var negKwToDistribute = [negKwsToAddToTheList[i][4],negKwsToAddToTheList[i][9],negKwsToAddToTheList[i][10]]
    var negKwToAdd = negKwsToAddToTheList[i][4]
    var negKwToAddMt = negKwsToAddToTheList[i][10]
    var listNameforFilter = negKwToDistribute[1]
    //Logger.log(negKwToDistribute)
    
    //This magic finds with list along with its column index
    var listNameWithIndex = listNames.filter(function filterArray(dataRow){return dataRow[0] === listNameforFilter})[0]
    //Logger.log(listNameWithIndex)
    
    //Let's get all current KWs in the negative list (the condition is to have the KW value AND match type
    var existingKws = sheet.getRange(3,listNameWithIndex[1],lastRow,2).getValues().filter(function(x){return x[0].length && x[1].length>0})
    //Logger.log(existingKws)
    
    //Let's see if if the new neg KW to add exists or not and then add the new KW
    if(existingKws.filter(function filterExistingNegKws(dataRow){return dataRow[0] === negKwToAdd && dataRow[1] === negKwToAddMt}).length>0)
      {Logger.log(negKwToAdd+' in '+ negKwToAddMt + ' already on the list. Won\'t add it again.')}
    else
      {
       //These new rows are helping to determing the last row for each list.
       SpreadsheetApp.flush()
       var currentLastRow = sheet.getLastRow()
       sheet.insertRowsAfter(currentLastRow, 2)
       var newLastRow = sheet.getMaxRows()
    
       var lastRowOfTheNegList = sheet.getRange(newLastRow,listNameWithIndex[1]).activate().getNextDataCell(SpreadsheetApp.Direction.UP).getRowIndex()
       //Logger.log(lastRowOfTheNegList)
       sheet.getRange(lastRowOfTheNegList+1,listNameWithIndex[1]).setValue(negKwToAdd)
       sheet.getRange(lastRowOfTheNegList+1,listNameWithIndex[1]+1).setValue(negKwToAddMt)
       SpreadsheetApp.flush()
      }
  }
  
  //Let's get rid of the blank rows at the bottom
  var lastRowOfTheSheet = sheet.getMaxRows()
  //Logger.log(lastRowOfTheSheet)

  var lastNonBlankRowOfTheSheet = sheet.getLastRow()
  //Logger.log(lastNonBlankRowOfTheSheet)
  
  var numberOfRowsToDelete = lastRowOfTheSheet-lastNonBlankRowOfTheSheet
  Logger.log('Number of rows to delete: '+(lastRowOfTheSheet-lastNonBlankRowOfTheSheet))
  try{if(numberOfRowsToDelete>0){sheet.deleteRows(lastNonBlankRowOfTheSheet+1, numberOfRowsToDelete)}}catch(err){Logger.log('')} 
   
  Logger.log('Checkpoint 152')

  //#############################################################################################
  //#############################################################################################
  //Let's get recent search terms from Google Ads
  //Let's prepare our spreadsheet first
  try{ss.deleteSheet(ss.getSheetByName(sqtReportSheetName))}
  catch(err){Logger.log('Sheet '+sqtReportSheetName+' does not exist so nothing to delete')}
  
  ss.insertSheet(sqtReportSheetName)
  var sqtReportSheet = ss.getSheetByName(sqtReportSheetName)
  sqtReportSheet.deleteColumns(10, 15)
  sqtReportSheet.setTabColor('yellow')
  sqtReportSheet.activate()
  //ss.moveActiveSheet(14)
  
  var query = 
      'SELECT CampaignName, AdGroupName, KeywordTextMatchingQuery, QueryTargetingStatus, Query, Impressions, Clicks, Cost, Conversions '+
      'FROM SEARCH_QUERY_PERFORMANCE_REPORT '+
      'WHERE Clicks >=' + clicksThreshold + ' ' +
      'DURING '+ lookbackWindow +'' 
  
  var report = AdsApp.report(query)
  
  report.exportToSheet(sqtReportSheet)
  
  sqtReportSheet.getRange('1:1').setBackground('yellow').setFontWeight('bold')
  
  //And conditional format for None in QueryTargetingStatus
  var rangeForCondtionalFormatting = sqtReportSheet.getRange('D2:D')
  var rule = SpreadsheetApp.newConditionalFormatRule()
    .whenTextContains('None')
    .setBackground('red')
    .setRanges([rangeForCondtionalFormatting])
    .build()
  
  var rules = sqtReportSheet.getConditionalFormatRules()
  rules.push(rule);
  sqtReportSheet.setConditionalFormatRules(rules)
  
  sqtReportSheet.getRange('J1').setValue('Select Negative KW List')
  sqtReportSheet.getRange('K1').setValue('Select Negative KW Match Type')
  SpreadsheetApp.flush()
  
  var lastQueryRow = sqtReportSheet.getLastRow()
  
  //Let's delete blank rows
  try{if(lastQueryRow<1000){sqtReportSheet.deleteRows(lastQueryRow+1, 1000-lastQueryRow-1)}}catch(err){Logger.log('')}
  
  //Let's add dropdowns for negative KW lists
  //Only if sqt terms were found though
  if(lastQueryRow>1){
    var dataValidationRuleLists = SpreadsheetApp.newDataValidation()
      .requireValueInList(listNamesWithoutIndexes, true)  
      .setAllowInvalid(false)
      .setHelpText('Select one of the negative shared lists.')
      .build()

    sqtReportSheet.getRange('J2').setDataValidation(dataValidationRuleLists)

    var dataValidationRuleMts = SpreadsheetApp.newDataValidation()
      //.requireValueInList(['exact','phrase','broad'], true)  
      .requireValueInList(['exact','phrase'], true)  
      .setAllowInvalid(false)
      .setHelpText('Select one of the match types.')
      .build()

    sqtReportSheet.getRange('K2').setDataValidation(dataValidationRuleMts)

    //Copy validations to the bottom
    sqtReportSheet.getRange('J2:K2').copyTo(sqtReportSheet.getRange('J2:K'+lastQueryRow))

    sqtReportSheet.autoResizeColumns(1, 11)
  }
  
  SpreadsheetApp.flush()
  Utilities.sleep(5000)
 
  
  //This is here to force refresh to query formula
  sqtNewNegKwsSheet.getRange('A1').clearContent()
  sqtNewNegKwsSheet.getRange('A1').setFormula(queryFormula)
 
  Logger.log('Checkpoint 235')
  
  
  //####################################################################
  //####################################################################
  //Lets remove existing campaign associations if enabled
  if(removeExistingAssociations=='YES'){
    var listsToDisassociate = listNamesWithoutIndexes
    
    Logger.log('listsToDisassociate: ' + listsToDisassociate)
    
    //Let's do regular campaigns
    for(i=0;i<listsToDisassociate.length;i++){
       var listToDisassociateSelected = AdsApp.negativeKeywordLists().withCondition('Name = "'+listsToDisassociate[i]+'"').get()
       
       while(listToDisassociateSelected.hasNext()){
         var listToDisassociate = listToDisassociateSelected.next()
         
         var campaignsAssignedToTheList = listToDisassociate.campaigns().get()

         var campaignListIdsToDisassociate = []
         var campaignListNamesToDisassociate = []

         while(campaignsAssignedToTheList.hasNext()){
           var campaignAssignedToTheList = campaignsAssignedToTheList.next()
           campaignListIdsToDisassociate.push(campaignAssignedToTheList.getId())
           campaignListNamesToDisassociate.push(campaignAssignedToTheList.getName()) 
         }  
       


         //Logger.log('List '+listsToDisassociate[i]+' has these campaigns: '+campaignListIdsToDisassociate)
         //Logger.log('List '+listsToDisassociate[i]+' has these campaigns: '+campaignListNamesToDisassociate)

        Logger.log('Checkpoint 304')

          //Let's remove assocations now
          if(campaignListIdsToDisassociate.length>0){
            var campaignsToRemoveTheListFrom = AdsApp.campaigns().withIds(campaignListIdsToDisassociate).get()
            //Logger.log('campaigns selected before the list removal')

            while(campaignsToRemoveTheListFrom.hasNext()){
             var campaignToRemoveTheListFrom = campaignsToRemoveTheListFrom.next()
             campaignToRemoveTheListFrom.removeNegativeKeywordList(listToDisassociate)  
            }  

          Logger.log('Campaigns removed from the list called '+listToDisassociate.getName())   
          }  
        
          Logger.log('Checkpoint 319')

          //Now shopping. You cannot easily say which shopping campaigns are assigned to which list.
          //So we have to go the other way around. Get all shopping camapaigns and delete all list in questions for them.
          //This is slower as we have to go through ALL campaigns and test them against all lists.
          var shoppingCampaignsToDisassociate = AdsApp.shoppingCampaigns().withCondition('Status = "ENABLED"').get()
          Logger.log('Shopping campaigns selected')

          while(shoppingCampaignsToDisassociate.hasNext()){
            var shoppingCampaignToDisassociate = shoppingCampaignsToDisassociate.next()

            for(y=0;y<listsToDisassociate.length;y++){
              var listToRemoveFromShoppingCampaigns = listsToDisassociate[y]
              //Logger.log('listToRemoveFromShoppingCampaigns: '+listToRemoveFromShoppingCampaigns)
              try{
                shoppingCampaignToDisassociate.removeNegativeKeywordList(AdsApp.negativeKeywordLists().withCondition('Name = "'+listsToDisassociate[y]+'"').get().next())
                //Logger.log(shoppingCampaignToDisassociate.getName()+' removed from the list called '+listsToDisassociate[y])
              }
              catch(err){Logger.log(shoppingCampaignToDisassociate.getName()+' did not have the '+listsToDisassociate[y]+' assigned.')}
            }
          } 
        }
      }  
    }
    

  //###################################################################################
  //###################################################################################
  //Okay, let's start to push neg lists to Google Ads
  var negListsFinalized = []
  
  for(i=0;i<listNames.length;i++){
  //TESTING ONLY for(i=0;i<2;i++){   
    
    //Logger.log('ListNames.length: '+listNames.length)
    
    var negListName = listNames[i][0]
    
    //Logger.log('Now processing: '+ negListName)
    //Logger.log('listNames[i][1]: '+ listNames[i][1])
    
    
    //This magic is filtering the array for existing negKws already! Check the function(x) part.
    var kwsToLoad = sheet.getRange(3,listNames[i][1],lastRow,2).getValues().filter(function(x){return x[0].length && x[1].length>0})
    
    //Logger.log('Now showing kwsToLoad which are alreayd filtered')
    //Logger.log(kwsToLoad)   
    
    var negListWithNameAndKws = [negListName,kwsToLoad]
    
    negListsFinalized.push(negListWithNameAndKws)
    
    //Logger.log(negListWithNameAndKws)                                             
  }
  
  //Logger.log('All neg KWs: ')
  //Logger.log(negListsFinalized)
  
  //Let's create the negative list.
  Logger.log('Now creating the negative KW lists.')  
  for(i=0;i<negListsFinalized.length;i++){    
    //Only create if the list does not exist yet.
    if(AdsApp.negativeKeywordLists().withCondition('Name = "'+negListsFinalized[i][0]+'"').get().totalNumEntities() == 1)
      {Logger.log('Neg list '+negListsFinalized[i][0]+' already exists. No need to create.')}
    
    else
      {AdsApp.newNegativeKeywordListBuilder().withName(negListsFinalized[i][0]).build()
       Logger.log('Neg list '+negListsFinalized[i][0]+' created.')}
  }
  
  
  //Let's wipe the previous neg KWs
  Logger.log('Now proceeding with deleting the previous negative KWs.')
  for(i=0;i<negListsFinalized.length;i++){
    try{
      var existingNegKws = AdsApp.negativeKeywordLists().withCondition('Name = "'+negListsFinalized[i][0]+'"').get().next().negativeKeywords().get()
      while(existingNegKws.hasNext){
        var negKwToDelete = existingNegKws.next()
        //Logger.log(negKwToDelete+' removed.')
        negKwToDelete.remove()
      }    
      Logger.log('Existing negative KWs deleted in '+negListsFinalized[i][0]+'.')
    }
              
    catch(err){Logger.log('Neg list '+negListsFinalized[i][0]+' does not exists so no negative KWs to delete.')}
  }

   //Let's get ready for creating the list of all neg KWs as vertical range as part of the next iteration
  var allNegsAsListSheet = ss.getSheetByName(allNegsAsListSheetName)
  var allNegsAsListSheetTotalRowCount = allNegsAsListSheet.getMaxRows()
  //clear the previous negs
  if(allNegsAsListSheetTotalRowCount>=2){
    allNegsAsListSheet.setFrozenRows(0)
    try{allNegsAsListSheet.deleteRows(2, allNegsAsListSheetTotalRowCount-1)}catch(err){Logger.log('')} 
  }
  
  //Let's add the new neg KWs
  Logger.log('Now adding new neg KWs into the lists.')
  for(i=0;i<negListsFinalized.length;i++){
    var listIntoWhichToAdd = negListsFinalized[i][0]
    Logger.log('Starting to add neg KWs into: '+listIntoWhichToAdd+'.')
    var negKwsToBeAdded = negListsFinalized[i][1]
    
    var broadList = []    
    var phraseList = []
    var exactList = []
    
    //Let's go into the list now
    for(y=0;y<negKwsToBeAdded.length;y++){
      var negKw = negKwsToBeAdded[y].toString().split(',')[0]
      var mt = negKwsToBeAdded[y].toString().split(',')[1]      

      if(mt=='broad'){broadList.push(negKw)}
      if(mt=='phrase'){phraseList.push('\"'+negKw+'\"')}
      if(mt=='exact'){exactList.push('['+negKw+']')}
   
    }
    
        
    //Let's push the neg KWs in bulk into google ads.
    AdsApp.negativeKeywordLists().withCondition('Name = "'+listIntoWhichToAdd+'"').get().next().addNegativeKeywords(broadList)
    AdsApp.negativeKeywordLists().withCondition('Name = "'+listIntoWhichToAdd+'"').get().next().addNegativeKeywords(phraseList)
    AdsApp.negativeKeywordLists().withCondition('Name = "'+listIntoWhichToAdd+'"').get().next().addNegativeKeywords(exactList)  
    Logger.log('Neg KWs added into '+listIntoWhichToAdd+'.')
    
    var broadListAsArrayOfArrays = []
    var phraseListAsArrayOfArrays = []    
    var exactListAsArrayOfArrays = []        
    
    for(u=0;u<broadList.length;u++){broadListAsArrayOfArrays.push([broadList[u]])}
    for(v=0;v<phraseList.length;v++){phraseListAsArrayOfArrays.push([phraseList[v]])}
    for(w=0;w<exactList.length;w++){exactListAsArrayOfArrays.push([exactList[w]])}
    
    var allNegsToExport = []
    //no broad negs on Bing
    //if(broadList.length>0){allNegsToExport.push(['broad', broadListAsArrayOfArrays])}
    if(phraseList.length>0){allNegsToExport.push(['phrase', phraseListAsArrayOfArrays])}
    if(exactList.length>0){allNegsToExport.push(['exact', exactListAsArrayOfArrays])}    
    
    for(k=0;k<allNegsToExport.length;k++){
      var numberOfKwsInTheList = allNegsToExport[k][1].length
      
      //Logger.log('numberOfKwsInTheList: '+numberOfKwsInTheList)
      
      if(numberOfKwsInTheList>0){      
        
        var allNegsAsListSheetLastRow = allNegsAsListSheet.getLastRow()
        //Logger.log('allNegsAsListSheetLastRow:'+allNegsAsListSheetLastRow)

        allNegsAsListSheet.insertRowsAfter(allNegsAsListSheetLastRow, numberOfKwsInTheList)

        Logger.log('Checkpoint 372')
        var rangeToPasteIntoA = allNegsAsListSheet.getRange('A'+(allNegsAsListSheetLastRow+1)+':A'+(allNegsAsListSheetLastRow+numberOfKwsInTheList))
        var rangeToPasteIntoB = allNegsAsListSheet.getRange('B'+(allNegsAsListSheetLastRow+1)+':B'+(allNegsAsListSheetLastRow+numberOfKwsInTheList))
        var rangeToPasteIntoC = allNegsAsListSheet.getRange('C'+(allNegsAsListSheetLastRow+1)+':C'+(allNegsAsListSheetLastRow+numberOfKwsInTheList))

        Logger.log('Checkpoint 388')
        //Logger.log(allNegsToExport[k][1])
        //Logger.log('allNegsToExport[k]: '+allNegsToExport[k][1])

        rangeToPasteIntoA.setValue(listIntoWhichToAdd)
        rangeToPasteIntoB.setValue(allNegsToExport[k][1])      
        rangeToPasteIntoC.setValue(allNegsToExport[k][0]) 
        }
    }  
  } 
  
  //Let's remove yellow background and bold font from the export of all negs
  allNegsAsListSheet.getRange('A2:C')
    .setBackground(null)
    .setFontWeight('normal')
  
  //Let's anchor the first row if more than 1 row on the sheet. If there is just one row in the sheet, an error will be thrown and the script will fail.
  if(allNegsAsListSheet.getMaxRows()>1){allNegsAsListSheet.setFrozenRows(1)}
  
  //Let's assign the lists to the campaigns now
  var listNamesOnly = []
  for(i=0;i<secondRow.length;i+=3){
    listNamesOnly.push(secondRow[i])
  }
  
  Logger.log(listNamesOnly)
  
  var filterRegexesOnly = []
  for(i=1;i<secondRow.length;i+=3){
    filterRegexesOnly.push(secondRow[i])
  }
  
  Logger.log(filterRegexesOnly)
  
  
  //Let's pair list names and their regexes
  var listNamesWithFilterRegexes = []
  
  for(i=0;i<listNamesOnly.length;i++){
    
    //let's figure out the position of the list name and then use its index to find the list's regexes
    var indexForRegexes = listNamesOnly.indexOf(listNamesOnly[i])
    
    var regex = filterRegexesOnly[indexForRegexes]
    if(listNamesOnly[i].length>0 && regex.length>0){
      listNamesWithFilterRegexes.push([listNamesOnly[i],regex])
    }
  }
  
  Logger.log(listNamesWithFilterRegexes)

  Logger.log('Checkpoint 351')
  
  
  //Let's print out the list names into the spreadsheet
  var negListsAsListSheet = ss.getSheetByName(negListsAsListSheetName)
  
  //Let's clear the previous content
  negListsAsListSheet.getRange('A2:C').clearContent()
  if(negListsAsListSheet.getMaxRows()>=22){
    negListsAsListSheet.setFrozenRows(0)
    try{negListsAsListSheet.deleteRows(22,negListsAsListSheet.getMaxRows()-21)}catch(err){Logger.log('')}
  }
  
  Logger.log('Checkpoint 442')
  Logger.log(listNamesWithFilterRegexes)
  for(q=0;q<listNamesWithFilterRegexes.length;q++){
    var lastRowNegListsAsListSheet = negListsAsListSheet.getLastRow()
    Logger.log('lastRowNegListsAsListSheet: '+lastRowNegListsAsListSheet)
    var listNameCell = negListsAsListSheet.getRange('A'+(lastRowNegListsAsListSheet+1))
    var listRegexCell = negListsAsListSheet.getRange('B'+(lastRowNegListsAsListSheet+1))
  
    Logger.log(listNameCell.getValue())
    Logger.log(listRegexCell.getValue())
    
    listNameCell.setValue(listNamesWithFilterRegexes[q][0])
    listRegexCell.setValue(listNamesWithFilterRegexes[q][1])
  }
 
  //anchor the first row
  if(negListsAsListSheet.getMaxRows()>1){negListsAsListSheet.setFrozenRows(1)}
        
  //###############################################################################################
  //###############################################################################################
  //Let's assign the list to campaigns based on the regexes
  var activeCampaigns = []
  
  //Let's assign the lists only to ENABLED campaigns
  var campaigns = AdsApp.campaigns().withCondition('Status = ENABLED').get()
  var shoppingCampaigns = AdsApp.shoppingCampaigns().withCondition('Status = ENABLED').get()
  
  while(campaigns.hasNext()){
    var campaign = campaigns.next()
    
    //Let's push campaign name and its ID so we can use the IDs for a quick filtering
    activeCampaigns.push([campaign.getName(), campaign.getId()])
  }
  
  while(shoppingCampaigns.hasNext()){
    var shoppingCampaign = shoppingCampaigns.next()
    
    //Let's push campaign name and its ID so we can use the IDs for a quick filtering - SHOPPING CAMPAIGNS
    activeCampaigns.push([shoppingCampaign.getName(), shoppingCampaign.getId()])
  }  
  
  
  Logger.log('List of active campaigns: '+activeCampaigns)
  
  //Assigning magic now
  //Logger.clear()
  Logger.log('Starting assigning magic now.')
  Logger.log('listNamesWithFilterRegexes: '+listNamesWithFilterRegexes)
  Logger.log('listNamesWithFilterRegexes.length: '+listNamesWithFilterRegexes.length)
  
  for(i=0;i<listNamesWithFilterRegexes.length;i++){
    
    var currentCombination = listNamesWithFilterRegexes[i]
    var listName = listNamesWithFilterRegexes[i][0]
    var regex = listNamesWithFilterRegexes[i][1]
    //Logger.clear()
    Logger.log('listNamesWithFilterRegex: '+listNamesWithFilterRegexes[i][0])
    
    var listNameToAssignToCampaigns = AdsApp.negativeKeywordLists().withCondition('Name = "'+listName+'"').get().next()
  
    if(listName.length>0 && regex.length>0){var filterRegex = new RegExp(regex)}
    
    Logger.log('currentCombination: '+currentCombination)
    Logger.log('Now processing: '+listName)
    Logger.log('Its regex is: '+filterRegex)
    
    if(typeof filterRegex!== 'undefined'){
      
      //this function is filtering the activeCampaigns list (campaign name + it's ID) just by running regex just over the campaign name! => hence the [0]
      function checkForRegex(x){return x[0].match(filterRegex)}

      var listOfCampaignsWhichShouldGetThisNegativeList = activeCampaigns.filter(checkForRegex)   
      //Logger.clear()

            
      var listOfCampaignsWhichShouldGetThisNegativeListIdsOnly = []             
      
      for(j=0;j<listOfCampaignsWhichShouldGetThisNegativeList.length;j++){
        listOfCampaignsWhichShouldGetThisNegativeListIdsOnly.push(listOfCampaignsWhichShouldGetThisNegativeList[j][1])
      }
      
      Logger.log('listOfCampaignsWhichShouldGetThisNegativeListIdsOnlyAsString: '+ listOfCampaignsWhichShouldGetThisNegativeListIdsOnly)
        
      
      //assign to campaigns - search
      var campaignsWhichNeedThisList = AdsApp.campaigns().withIds(listOfCampaignsWhichShouldGetThisNegativeListIdsOnly).get()
      Logger.log('Campaigns selected for neg list assignment')
      
      while(campaignsWhichNeedThisList.hasNext()){
        var campaignWhichNeedsThisList = campaignsWhichNeedThisList.next()
        campaignWhichNeedsThisList.addNegativeKeywordList(listNameToAssignToCampaigns)
        }
      //Logger.log('Neg list called '+listName+' was assigned to this campaign: '+listOfCampaignsWhichShouldGetThisNegativeList[y])
      Logger.log('I\'m done with assigning (Search): '+listName)
      
      //assign to shopping - shopping
      var shoppingCampaignsWhichNeedThisList = AdsApp.shoppingCampaigns().withIds(listOfCampaignsWhichShouldGetThisNegativeListIdsOnly).get()
      Logger.log('Campaigns selected for neg list assignment')
      
      while(shoppingCampaignsWhichNeedThisList.hasNext()){
        var shoppingCampaignWhichNeedsThisList = shoppingCampaignsWhichNeedThisList.next()
        shoppingCampaignWhichNeedsThisList.addNegativeKeywordList(listNameToAssignToCampaigns)
        }
      //Logger.log('Neg list called '+listName+' was assigned to this campaign: '+listOfCampaignsWhichShouldGetThisNegativeList[y])
      Logger.log('I\'m done with assigning (Shopping): '+listName)      
            
      }
    }


  Logger.log('Checkpoint 401')

  //##################################################################################################
  //##################################################################################################
  //GA Reporting
  
  //GA Reporting  
  var payload = {
    'v': '1',
    'tid': 'UA-69459605-1',
    't': 'event',
    'cid' : Utilities.getUuid(),
    'z' : Math.floor(Math.random() * 10E7),
    'ds' : 'google_ads_script',
    'cn' : 'script-negative_kw_manager',
    'cs' : 'google_ads_script',
    'cm' : 'google_ads_script',
    'ec' : 'script_run',
    'ea' : 'script_run_completed',
    'el' : 'script-negative_kw_manager'
    };
  
  var options = {
    "method" : "post",
    "payload" : payload
   };
  
  //Send the hit to GA if allowed
  if(reportingAllowed == 'YES'){UrlFetchApp.fetch("http://www.google-analytics.com/collect", options)};    
  
  
  //Send a confirmation email
  var execinfo = AdsApp.getExecutionInfo()
  var logsAsText = Logger.getLog().split('\n').join('<br>')
  
  var subjectText = 'Negative KWs Synced in ' + accountName + ' | ' + accountId
  var bodyText =
       (
       execinfo + '<br>' + '<br>' +
       logsAsText + '<br>' + '<br>' +
       'The spreadsheet is here: https://docs.google.com/spreadsheets/d/'+spreadsheetId     
       )
  
  if (emailAddress.length>0){
    
      MailApp.sendEmail(
        {to:emailAddress,
         subject: subjectText, 
         htmlBody: bodyText
        })
      Logger.log('Email sent')
  }
    
  //##################################################################################################
  //##################################################################################################  
  Logger.log('I\'m finished with the script.')
  
  }catch(err){
    Logger.log(err)
    MailApp.sendEmail(emailAddress, 'Negative Keyword Sync Just Failed! | ' + accountName + ' | ' + accountId, err)}

}
